# This Pipe line has 3 stages, this is a very basic pipeline
# variables
variables:
  ARTIFACT_NAME: jpe-v$CI_PIPELINE_IID.jar # CI_PIPELINE_IID - is predefined gitlab pipeline id
                                           # this is added to uniquly identify each artifacts
                                           # refer - https://docs.gitlab.com/ee/ci/variables/predefined_variables.html
  APP_NAME: cars-api

#stages
stages:
  - build
  - test
  - deploy

build:
  stage: build
  # pulls the docker image
  image: openjdk:12-alpine
  script:
    - sed -i "s/CI_INFO_APP_VERSION/$CI_PIPELINE_IID/" ./src/main/resources/application.properties
    - sed -i "s/CI_INFO_APP_COMMIT/$CI_COMMIT_SHORT_SHA/" ./src/main/resources/application.properties
    - sed -i "s/CI_INFO_APP_BRANCH/$CI_COMMIT_BRANCH/" ./src/main/resources/application.properties
    # https://stackoverflow.com/questions/17668265/gradlew-permission-denied
    - chmod +x gradlew # to resolve Permission denied on ./gradlew build
    - ./gradlew build
    # this step is needed since we added version to artifact when its deploy to EBS
    - mv ./build/libs/jpe.jar ./build/libs/$ARTIFACT_NAME
  artifacts:
    paths:
      - ./build/libs

smoke test:
  stage: test
  image: openjdk:12-alpine
  # this runs before script commands
  before_script:
    # command to install curl on alpine image
    - apk --no-cache add curl
  script:
    - java -jar ./build/libs/$ARTIFACT_NAME &
    # sleep 10 seconds
    - sleep 10
    - curl http://localhost:5000/actuator/health | grep "UP"

deploy:
  stage: deploy
  image:
    name: banst/awscli
    # gitlab ci need it as it do not allow entry point (what is entry point in docker ?)
    entrypoint: [""]
  before_script:
    - apk --no-cache add curl
    # jq is tool for json parsing in terminal
    - apk --no-cache add jq
  script:
    - aws configure  set region us-east-1
    - aws s3 cp ./build/libs/$ARTIFACT_NAME s3://$S3_BUCKET/$ARTIFACT_NAME
    #creating version
    - aws elasticbeanstalk create-application-version --application-name $APP_NAME --version-label $CI_PIPELINE_IID --source-bundle S3Bucket=$S3_BUCKET,S3Key=$ARTIFACT_NAME
    # updating env
    - CNAME=$(aws elasticbeanstalk update-environment --application-name $APP_NAME --environment-name "CarsApi-env" --version-label $CI_PIPELINE_IID | jq '.CNAME' --raw-output)
  after_script:
    #- sleep 45
    - curl http://$CNAME/actuator/info | grep $CI_PIPELINE_IID
    - curl http://$CNAME/actuator/health | grep "UP"